## exhale 0.2.3

=== debian/changelog ===
exhale (0.2.3-2) unstable; urgency=medium

  * Source-only upload.
  * Add Enhances: python3-sphinx

 -- Timo Röhling <roehling@debian.org>  Thu, 28 Oct 2021 08:44:03 +0200

exhale (0.2.3-1) unstable; urgency=medium

  * Initial release (Closes: #994609)

 -- Timo Röhling <roehling@debian.org>  Sun, 19 Sep 2021 21:45:40 +0200

=== debian/rules ===
#!/usr/bin/make -f

export PYBUILD_TEST_ARGS = $(CURDIR)/testing -m "not setup_raises" -k "not CPPPimpl"

%:
	dh $@ --buildsystem=pybuild

execute_after_dh_auto_install:
	rm debian/*/usr/lib/python*/dist-packages/exhale/data/treeView-bootstrap/bootstrap-treeview/LICENSE
	rm debian/*/usr/lib/python*/dist-packages/exhale/data/treeView/collapsible-lists/LICENSE.md

## exhale 0.3.1

=== testing/projects/CMakeLists.txt ===
########################################################################################
# This file is dedicated to the public domain.  If your jurisdiction requires a        #
# specific license:                                                                    #
#                                                                                      #
# Copyright (c) Stephen McDowell, 2017-2022                                            #
# License:      CC0 1.0 Universal                                                      #
# License Text: https://creativecommons.org/publicdomain/zero/1.0/legalcode            #
########################################################################################
#                                                                                      #
# WARNING:                                                                             #
# What you find below as well as in other CMakeLists.txt in nested directories should  #
# *NOT* be regarded as holistically good CMake practice.  I have deliberately chosen   #
# to set, modify, configure, or alter certain behaviors that should ordinarily be left #
# up to the user to configure.  This is done primarily for two reasons:                #
#                                                                                      #
# 1. It makes my life easier for getting code coverage for the non-python files.       #
# 2. This is *NOT* a "real" CMake project!!!                                           #
#                                                                                      #
# You have been warned.  If you choose to continue reading, I cannot guarantee your    #
# safety as your eyes may bleed, or you may spontaneously combust.                     #
#                                                                                      #
########################################################################################
cmake_minimum_required(VERSION 3.13 FATAL_ERROR)
project(exhale-projects)

# Forcibly setting this to make CI easier.
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin)
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)
set(CMAKE_CXX_STANDARD 14)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)
set(CMAKE_BUILD_TYPE "Debug") # required for code coverage

# Download the test suite utilities (Catch2 <3)
file(
  DOWNLOAD
    https://raw.githubusercontent.com/catchorg/Catch2/v2.x/single_include/catch2/catch.hpp
    ${CMAKE_CURRENT_BINARY_DIR}/include/catch2/catch.hpp
)

# Download the C++ code coverage utilities for non-Windows.
if (NOT WIN32)
  file(
    DOWNLOAD
      https://raw.githubusercontent.com/bilke/cmake-modules/master/CodeCoverage.cmake
      ${CMAKE_CURRENT_BINARY_DIR}/cmake/CodeCoverage.cmake
  )
  list(APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_BINARY_DIR}/cmake)
endif()

# The "main" testing executable, only write once so as not to force a re-build every time
if (NOT EXISTS ${CMAKE_CURRENT_BINARY_DIR}/src/main.cpp)
  file(
    WRITE ${CMAKE_CURRENT_BINARY_DIR}/src/main.cpp
    "#define CATCH_CONFIG_MAIN\n#include <catch2/catch.hpp>\n"
  )
endif()

# Add an interface library for sub-projects to add dependencies to.
# Subdirectories will modify the interface include directories / link libraries etc so
# that the final testing executable depends on the respective libraries built by
# sub-projects (via add_subdirectory).
add_library(exhale-projects-tests-interface INTERFACE)
target_include_directories(exhale-projects-tests-interface
  INTERFACE
    ${CMAKE_CURRENT_BINARY_DIR}/include
)

# The main testing executable target.
# Subdirectories will modify the target_sources() of this executable to append their
# respective tests.
add_executable(exhale-projects-unit-tests
  ${CMAKE_CURRENT_BINARY_DIR}/src/main.cpp
)
target_link_libraries(exhale-projects-unit-tests
  PRIVATE
    exhale-projects-tests-interface
)

# Setup code coverage (changes CMAKE_<LANG>_FLAGS, must be done before add_subdirectory calls).
if (NOT WIN32)
  # See ${CMAKE_BINARY_DIR}/cmake/CodeCoverage.cmake, this trims the local genhtml report
  set(COVERAGE_GCOVR_EXCLUDES
    "'/usr/*'"
    "'${CMAKE_BINARY_DIR}/*'"
  )
  include(CodeCoverage)
  append_coverage_compiler_flags()
endif()

# Convenience definitions / macro for OpenCppCoverage --sources coordination.
if (MSVC)
  set(OPEN_CPP_COVERAGE_SOURCE_LIST ) # Create empty list, modified in child projects
endif()

# Call in subdirectories, it's a macro and expands using CMAKE_CURRENT_SOURCE_DIR, so
# for example just do
#
#                                space delimits new arguments
#                                              v
#     add_open_cpp_coverage_source_dirs(include src)
#
# Then `${CMAKE_CURRENT_SOURCE_DIR}/include` and `${CMAKE_CURRENT_SOURCE_DIR}/src`
# will be appended to OPEN_CPP_COVERAGE_SOURCE_LIST which will then be set in
# PARENT_SCOPE so that it updates across all projects.
macro(add_open_cpp_coverage_source_dirs)
  if (MSVC)
    foreach (dir ${ARGV})
      list(APPEND OPEN_CPP_COVERAGE_SOURCE_LIST ${CMAKE_CURRENT_SOURCE_DIR}/${dir})
    endforeach()
    set(OPEN_CPP_COVERAGE_SOURCE_LIST "${OPEN_CPP_COVERAGE_SOURCE_LIST}" PARENT_SCOPE)
  endif()
endmacro()

# List of projects to validate have code that actually compiles xD
set(EXHALE_PROJECTS
  c_maths
  cpp_func_overloads
  cpp_long_names
  cpp_dir_underscores
  cpp_nesting
  cpp_pimpl
  "cpp with spaces"
)
# At this time I care not to figure out how to actually get a functioning fortran
# compiler setup to work with Visual Studio.  Maybe if Microsoft ever cares enough to
# provide legitimate support for this, I may decide to actually test this.
if (NOT WIN32 AND NOT MSVC)
  list(APPEND EXHALE_PROJECTS cpp_fortran_mixed)
endif()

foreach (proj ${EXHALE_PROJECTS})
  add_subdirectory(${CMAKE_CURRENT_SOURCE_DIR}/${proj})
endforeach()

# NOTE: must be done *AFTER* all add_subdirectory are finished so that the target
#       exhale-projects-unit-tests has all of the correct sources.
if (UNIX)
  setup_target_for_coverage_gcovr_xml(
    NAME coverage-xml
    EXECUTABLE $<TARGET_FILE:exhale-projects-unit-tests>
    DEPENDENCIES exhale-projects-unit-tests
  )
  setup_target_for_coverage_gcovr_html(
    NAME coverage-html
    EXECUTABLE $<TARGET_FILE:exhale-projects-unit-tests>
    DEPENDENCIES exhale-projects-unit-tests
  )
elseif (MSVC)
  # Require user (or AppVeyor script) have already installed OpenCppCoverage.exe.
  find_program(OPEN_CPP_COVERAGE_EXE OpenCppCoverage.exe)
  if (OPEN_CPP_COVERAGE_EXE STREQUAL "OPEN_CPP_COVERAGE_EXE-NOTFOUND")
    message(FATAL_ERROR
      "OpenCppCoverage.exe not found, is it in your $PATH?  You can install it "
      "with Chocolatey: `choco install opencppcoverage`.  Alternatively, follow "
      "the instructions here: https://github.com/OpenCppCoverage/OpenCppCoverage"
    )
  endif()

  # Populate a list of --sources to supply to OpenCppCoverage.
  foreach (dir ${OPEN_CPP_COVERAGE_SOURCE_LIST})
    file(TO_NATIVE_PATH "${dir}" native_path)
    list(APPEND OPEN_CPP_COVERAGE_SOURCES "--sources \"${native_path}\"")
  endforeach()

  # Add a custom target that launches OpenCppCoverage exporting to cobertura format
  # which codecov.io can understand.  Invoke from command-line using:
  #     cmake --build . --target coverage-xml
  add_custom_target(
    coverage-xml
    COMMAND ${OPEN_CPP_COVERAGE_EXE} ${OPEN_CPP_COVERAGE_SOURCES}
      --working_dir "\"${PROJECT_BINARY_DIR}\""
      --export_type cobertura:coverage.xml
      -- $<TARGET_FILE:exhale-projects-unit-tests>
    WORKING_DIRECTORY ${PROJECT_BINARY_DIR}
    DEPENDS exhale-projects-unit-tests
  )

  # Add a custom target that launches OpenCppCoverage generating HTML coverage for
  # local viewing.  Invoke from command-line using:
  #     cmake --build . --target coverage-html
  add_custom_target(
    coverage-html
    COMMAND ${OPEN_CPP_COVERAGE_EXE} ${OPEN_CPP_COVERAGE_SOURCES}
      --working_dir "\"${PROJECT_BINARY_DIR}\""
      --export_type html:coverage_html
      -- $<TARGET_FILE:exhale-projects-unit-tests>
    WORKING_DIRECTORY ${PROJECT_BINARY_DIR}
    DEPENDS exhale-projects-unit-tests
  )
endif()

=== testing/projects/c_maths/CMakeLists.txt ===
########################################################################################
# This file is dedicated to the public domain.  If your jurisdiction requires a        #
# specific license:                                                                    #
#                                                                                      #
# Copyright (c) Stephen McDowell, 2017-2022                                            #
# License:      CC0 1.0 Universal                                                      #
# License Text: https://creativecommons.org/publicdomain/zero/1.0/legalcode            #
########################################################################################
cmake_minimum_required(VERSION 3.13 FATAL_ERROR)
project(c-maths LANGUAGES C)

# Add the c-maths library
add_library(c-maths "")
target_sources(c-maths
  PUBLIC
    ${CMAKE_CURRENT_SOURCE_DIR}/include/c_maths.h
  PRIVATE
    ${CMAKE_CURRENT_SOURCE_DIR}/src/c_maths.c
)
target_include_directories(c-maths
  PUBLIC
    ${CMAKE_CURRENT_SOURCE_DIR}/include
)

# Add the tests and link against the c-maths library.
target_sources(exhale-projects-unit-tests
  PUBLIC
    ${CMAKE_CURRENT_SOURCE_DIR}/src/tests.cpp
)
target_link_libraries(exhale-projects-tests-interface
  INTERFACE
    c-maths
)

add_open_cpp_coverage_source_dirs(include src)

=== testing/projects/cpp with spaces/CMakeLists.txt ===
########################################################################################
# This file is dedicated to the public domain.  If your jurisdiction requires a        #
# specific license:                                                                    #
#                                                                                      #
# Copyright (c) Stephen McDowell, 2017-2022                                            #
# License:      CC0 1.0 Universal                                                      #
# License Text: https://creativecommons.org/publicdomain/zero/1.0/legalcode            #
########################################################################################
cmake_minimum_required(VERSION 3.13 FATAL_ERROR)
project(cpp-with-spaces LANGUAGES CXX)

# Add the cpp-with-spaces library
add_library(cpp-with-spaces "")
target_sources(cpp-with-spaces
  PUBLIC
    "${CMAKE_CURRENT_SOURCE_DIR}/include/with spaces/with spaces.hpp"
  PRIVATE
    "${CMAKE_CURRENT_SOURCE_DIR}/src/with spaces.cpp"
)
target_include_directories(cpp-with-spaces
  PUBLIC
    ${CMAKE_CURRENT_SOURCE_DIR}/include
)

# Add the tests and link against the c-maths library.
target_sources(exhale-projects-unit-tests
  PUBLIC
    ${CMAKE_CURRENT_SOURCE_DIR}/src/tests.cpp
)
target_link_libraries(exhale-projects-tests-interface
  INTERFACE
    cpp-with-spaces
)

add_open_cpp_coverage_source_dirs(include src)

=== testing/projects/cpp_dir_underscores/CMakeLists.txt ===
########################################################################################
# This file is dedicated to the public domain.  If your jurisdiction requires a        #
# specific license:                                                                    #
#                                                                                      #
# Copyright (c) Stephen McDowell, 2017-2022                                            #
# License:      CC0 1.0 Universal                                                      #
# License Text: https://creativecommons.org/publicdomain/zero/1.0/legalcode            #
########################################################################################
cmake_minimum_required(VERSION 3.13 FATAL_ERROR)
project(cpp-dir-underscores LANGUAGES CXX)

# "Header only library": add tests and include the directory
target_sources(exhale-projects-unit-tests
  PUBLIC
    ${CMAKE_CURRENT_SOURCE_DIR}/src/tests.cpp
)
target_include_directories(exhale-projects-tests-interface
  INTERFACE
    ${CMAKE_CURRENT_SOURCE_DIR}/include
)

add_open_cpp_coverage_source_dirs(include src)

=== testing/projects/cpp_func_overloads/CMakeLists.txt ===
########################################################################################
# This file is dedicated to the public domain.  If your jurisdiction requires a        #
# specific license:                                                                    #
#                                                                                      #
# Copyright (c) Stephen McDowell, 2017-2022                                            #
# License:      CC0 1.0 Universal                                                      #
# License Text: https://creativecommons.org/publicdomain/zero/1.0/legalcode            #
########################################################################################
cmake_minimum_required(VERSION 3.13 FATAL_ERROR)
project(cpp-func-overloads LANGUAGES CXX)

# Add the cpp-func-overloads library
add_library(cpp-func-overloads "")
target_sources(cpp-func-overloads
  PUBLIC
    ${CMAKE_CURRENT_SOURCE_DIR}/include/overload/overload.hpp
  PRIVATE
    ${CMAKE_CURRENT_SOURCE_DIR}/src/overload.cpp
)
target_include_directories(cpp-func-overloads
  PUBLIC
    ${CMAKE_CURRENT_SOURCE_DIR}/include
)

# Add the tests and link against the cpp-func-overloads library.
target_sources(exhale-projects-unit-tests
  PUBLIC
    ${CMAKE_CURRENT_SOURCE_DIR}/src/tests.cpp
)
target_link_libraries(exhale-projects-tests-interface
  INTERFACE
    cpp-func-overloads
)

add_open_cpp_coverage_source_dirs(include src)

=== testing/projects/cpp_long_names/CMakeLists.txt ===
########################################################################################
# This file is dedicated to the public domain.  If your jurisdiction requires a        #
# specific license:                                                                    #
#                                                                                      #
# Copyright (c) Stephen McDowell, 2017-2022                                            #
# License:      CC0 1.0 Universal                                                      #
# License Text: https://creativecommons.org/publicdomain/zero/1.0/legalcode            #
########################################################################################
cmake_minimum_required(VERSION 3.13 FATAL_ERROR)
project(cpp-long-names LANGUAGES CXX)

# Windows cannot handle the full test case because of its antiquated filesystem.
if (NOT WIN32)
  # Will re-use the methods defined in testing/tests/cpp_long_names.py to generate the
  # full test case directory paths.
  find_program(PYTHON_EXECUTABLE python)
  if (PYTHON_EXECUTABLE STREQUAL PYTHON_EXECUTABLE-NOTFOUND)
    message(FATAL_ERROR "This project requires python in order to generate the full test case.")
  endif()

  # Using git rev-parse to make life easier to find the cpp_long_names.py test case.
  find_program(GIT_EXECUTABLE git)
  if (GIT_EXECUTABLE STREQUAL GIT_EXECUTABLE-NOTFOUND)
    message(FATAL_ERROR "This project requires git in order to generate the full test case.")
  endif()

  # Acquire the full path to the repository root and create the path to where the
  # cpp_long_names.py file lives.
  execute_process(
    COMMAND         ${GIT_EXECUTABLE} rev-parse --show-toplevel
    RESULT_VARIABLE GIT_EXIT_CODE
    OUTPUT_VARIABLE REPOSITORY_ROOT
    ERROR_VARIABLE  GIT_FAILURE_MESSAGE
  )
  if (GIT_EXIT_CODE)
    message(FATAL_ERROR "Non-zero exit code of [${GIT_EXIT_CODE}] executing 'git rev-parse --show-toplevel'. ${GIT_FAILURE_MESSAGE}")
  elseif (REPOSITORY_ROOT MATCHES "^$")
    message(FATAL_ERROR "Impossible empty string result of 'git rev-parse --show-toplevel'...")
  endif()
  # Remove trailing newline from command-line output.
  string(REGEX REPLACE "\n" "" REPOSITORY_ROOT "${REPOSITORY_ROOT}")
  set(CPP_LONG_NAMES_PY "${REPOSITORY_ROOT}/testing/tests/cpp_long_names.py")
  if (NOT EXISTS "${CPP_LONG_NAMES_PY}")
    message(FATAL_ERROR "Could not find the file [${CPP_LONG_NAMES_PY}]!")
  endif()

  # Create a script to call the function to make directories.  If only there was
  # textwrap.dedent(...) in CMake x0
  string(CONCAT GENERATE_ABSURD_SCRIPT_CONTENTS
    "import os\n"
    "import sys\n"
    "\n"
    "\n"
    "if __name__ == '__main__':\n"
    "    try:\n"
    "        # Make it so we can import 'exhale' and 'testing'\n"
    "        repository_root = os.path.abspath('${REPOSITORY_ROOT}')\n"
    "        sys.path.insert(0, repository_root)\n"
    "\n"
    "        from testing.tests import cpp_long_names\n"
    "        cpp_long_names.create_absurd_directory_structure()\n"
    "\n"
    "        # Print out what we just made verify it was created in CMake.\n"
    "        sys.stdout.write(os.path.join(\n"
    "            cpp_long_names.ABSURD_DIRECTORY_PATH, 'a_file.hpp'\n"
    "        ))\n"
    "        sys.exit(0)\n"
    "    except Exception as e:\n"
    "        sys.stderr.write('Critical error trying to make the absurd path: {}'.format(e))\n"
    "        sys.exit(1)\n"
  )
  set(GENERATE_ABSURD_SCRIPT "${CMAKE_CURRENT_BINARY_DIR}/prepare_cpp_long_names.py")

  # Only generate this once to prevent re-builds.
  if (NOT EXISTS ${GENERATE_ABSURD_SCRIPT})
    file(WRITE "${GENERATE_ABSURD_SCRIPT}" "${GENERATE_ABSURD_SCRIPT_CONTENTS}")

    # Call the script to generate the absurd path.
    execute_process(
      COMMAND ${PYTHON_EXECUTABLE} ${GENERATE_ABSURD_SCRIPT}
      RESULT_VARIABLE GENERATE_ABSURD_SCRIPT_EXIT_CODE
      OUTPUT_VARIABLE ABSURD_FILE_PATH
      ERROR_VARIABLE  GENERATE_ABSURD_SCRIPT_FAILURE_MESSAGE
    )
    if (GENERATE_ABSURD_SCRIPT_EXIT_CODE)
      message(FATAL_ERROR "Could not generate the absurd file path. ${GENERATE_ABSURD_SCRIPT_FAILURE_MESSAGE}")
    endif()
  endif()
endif()


# "Header only library": add tests and include the directory
target_sources(exhale-projects-unit-tests
  PUBLIC
    ${CMAKE_CURRENT_SOURCE_DIR}/src/tests.cpp
)
target_include_directories(exhale-projects-tests-interface
  INTERFACE
    ${CMAKE_CURRENT_SOURCE_DIR}/include
)

add_open_cpp_coverage_source_dirs(include src)

=== testing/projects/cpp_nesting/CMakeLists.txt ===
########################################################################################
# This file is dedicated to the public domain.  If your jurisdiction requires a        #
# specific license:                                                                    #
#                                                                                      #
# Copyright (c) Stephen McDowell, 2017-2022                                            #
# License:      CC0 1.0 Universal                                                      #
# License Text: https://creativecommons.org/publicdomain/zero/1.0/legalcode            #
########################################################################################
cmake_minimum_required(VERSION 3.13 FATAL_ERROR)
project(cpp-nesting LANGUAGES CXX)

# "Header only library": add tests and include the directory
target_sources(exhale-projects-unit-tests
  PUBLIC
    ${CMAKE_CURRENT_SOURCE_DIR}/src/tests.cpp
)
target_include_directories(exhale-projects-tests-interface
  INTERFACE
    ${CMAKE_CURRENT_SOURCE_DIR}/include
)

add_open_cpp_coverage_source_dirs(include src)

=== debian/changelog ===
exhale (0.3.1-1) unstable; urgency=medium

  * New upstream version 0.3.1

 -- Timo Röhling <roehling@debian.org>  Sat, 19 Feb 2022 15:11:10 +0100

exhale (0.3.0-2) unstable; urgency=medium

  * Fix autopkgtest after config migrated to pyproject.toml

 -- Timo Röhling <roehling@debian.org>  Fri, 11 Feb 2022 10:52:51 +0100

exhale (0.3.0-1) unstable; urgency=medium

  * New upstream version 0.3.0
  * Refresh patches
    - Drop Do-not-emit-empty-hierarchy-files.patch (applied upstream)

 -- Timo Röhling <roehling@debian.org>  Thu, 10 Feb 2022 09:19:59 +0100

exhale (0.2.4-3) unstable; urgency=medium

  * Do not emit empty hierarchy files

 -- Timo Röhling <roehling@debian.org>  Wed, 15 Dec 2021 22:47:16 +0100

exhale (0.2.4-2) unstable; urgency=medium

  * Fix autopkgtest regression

 -- Timo Röhling <roehling@debian.org>  Sun, 05 Dec 2021 19:52:34 +0100

exhale (0.2.4-1) unstable; urgency=medium

  * New upstream version 0.2.4
  * Update test rules

 -- Timo Röhling <roehling@debian.org>  Fri, 03 Dec 2021 16:07:13 +0100

=== debian/control ===
Source: exhale
Section: python
Priority: optional
Maintainer: Debian Python Team <team+python@tracker.debian.org>
Uploaders: Timo Röhling <roehling@debian.org>
Build-Depends:
  debhelper-compat (= 13),
  dh-sequence-python3,
  python3-all,
  python3-breathe,
  python3-bs4,
  python3-ipdb <!nocheck>,
  python3-lxml,
  python3-setuptools,
  python3-six,
  python3-sphinx (>= 1.6.1),
  python3-pytest <!nocheck>
Homepage: https://exhale.readthedocs.io/en/latest/
Standards-Version: 4.6.0
Rules-Requires-Root: no
Vcs-Git: https://salsa.debian.org/python-team/packages/exhale.git
Vcs-Browser: https://salsa.debian.org/python-team/packages/exhale

Package: python3-exhale
Architecture: all
Multi-Arch: foreign
Depends: ${python3:Depends}, ${misc:Depends}, doxygen
Enhances: python3-sphinx
Description: Sphinx automated C++ API generation support
 Exhale is a Sphinx extension that depends on the excellent Breathe
 extension which enables parsing Doxygen documentation into the Sphinx
 domain. Exhale provides a layer of automation, enabling launching
 Doxygen and generating the full website all from your conf.py.

=== debian/rules ===
--- 
+++ 
@@ -1,6 +1,6 @@
 #!/usr/bin/make -f
 
-export PYBUILD_TEST_ARGS = $(CURDIR)/testing -m "not setup_raises" -k "not CPPPimpl"
+export PYBUILD_TEST_ARGS = $(CURDIR)/testing -m "not setup_raises" -k "not CPPNestingPages"
 
 %:
 	dh $@ --buildsystem=pybuild

=== debian/tests/control ===
Tests: run-test-suite
Depends: @, python3-pytest, python3-ipdb

=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/exhale-$1\.tar\.gz/ \
 https://github.com/svenevs/exhale/releases/latest .*/v?(\d\S+)\.tar\.gz

## exhale 0.3.5

=== debian/changelog ===
exhale (0.3.5-1) unstable; urgency=medium

  * New upstream version 0.3.5

 -- Timo Röhling <roehling@debian.org>  Mon, 25 Jul 2022 13:37:51 +0200

exhale (0.3.4-1) unstable; urgency=medium

  * New upstream version 0.3.4

 -- Timo Röhling <roehling@debian.org>  Mon, 20 Jun 2022 09:39:45 +0200

exhale (0.3.3-1) unstable; urgency=medium

  * Remove constraints unnecessary since buster
  * New upstream version 0.3.3
  * Bump Standards-Version to 4.6.1

 -- Timo Röhling <roehling@debian.org>  Sun, 19 Jun 2022 23:02:48 +0200

=== debian/control ===
--- 
+++ 
@@ -6,17 +6,18 @@
 Build-Depends:
   debhelper-compat (= 13),
   dh-sequence-python3,
+  pybuild-plugin-pyproject,
   python3-all,
   python3-breathe,
   python3-bs4,
   python3-ipdb <!nocheck>,
   python3-lxml,
+  python3-pytest <!nocheck>,
   python3-setuptools,
   python3-six,
-  python3-sphinx (>= 1.6.1),
-  python3-pytest <!nocheck>
+  python3-sphinx,
 Homepage: https://exhale.readthedocs.io/en/latest/
-Standards-Version: 4.6.0
+Standards-Version: 4.6.1
 Rules-Requires-Root: no
 Vcs-Git: https://salsa.debian.org/python-team/packages/exhale.git
 Vcs-Browser: https://salsa.debian.org/python-team/packages/exhale

## exhale 0.3.6

=== docs/requirements.txt ===
sphinx==4.3.1
sphinx_rtd_theme==1.0.0
sphinx-issues
# exhale requirements
beautifulsoup4
lxml
breathe
six
# test imports
pytest
pytest-raises>=0.10

=== testing/projects/CMakeLists.txt ===
--- 
+++ 
@@ -27,7 +27,7 @@
 set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin)
 set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)
 set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)
-set(CMAKE_CXX_STANDARD 14)
+set(CMAKE_CXX_STANDARD 17)
 set(CMAKE_CXX_STANDARD_REQUIRED ON)
 set(CMAKE_CXX_EXTENSIONS OFF)
 set(CMAKE_BUILD_TYPE "Debug") # required for code coverage

=== testing/projects/cpp_fortran_mixed/CMakeLists.txt ===
########################################################################################
# This file is dedicated to the public domain.  If your jurisdiction requires a        #
# specific license:                                                                    #
#                                                                                      #
# Copyright (c) Stephen McDowell, 2017-2022                                            #
# License:      CC0 1.0 Universal                                                      #
# License Text: https://creativecommons.org/publicdomain/zero/1.0/legalcode            #
########################################################################################
cmake_minimum_required(VERSION 3.13 FATAL_ERROR)
project(cpp-fortran-mixed LANGUAGES C CXX Fortran)

if (WIN32 OR MSVC)
  message(FATAL_ERROR "The cpp-fortran-mixed library is not configured for windows support.")
endif()

# The extern "C" { ... } bit calling the fortran code is not to be run with
# coverage flags, because they break compilation...
set(NEW_CMAKE_C_FLAGS "")
foreach (flag ${CMAKE_C_FLAGS})
  if (NOT ${flag} MATCHES "--coverage" AND NOT ${flag} MATCHES "-fprofile-args" AND NOT ${flag} MATCHES "=ftest-coverage")
    list(APPEND NEW_CMAKE_C_FLAGS ${flag})
  endif()
endforeach()
set(CMAKE_C_FLAGS ${NEW_CMAKE_C_FLAGS}) # don't do PARENT_SCOPE here ;)

# Add the cpp-fortran-mixed library
add_library(cpp-fortran-mixed "")

# Generates the FC_MODULE macros for calling from extern "C" { ... } code.
include(FortranCInterface)
FortranCInterface_HEADER(
    ${CMAKE_CURRENT_BINARY_DIR}/include/convert/fortran_interface.h
    MACRO_NAMESPACE "FC_"
)

# Set the sources for the cpp-fortran-mixed library.
target_sources(cpp-fortran-mixed
  PUBLIC
    ${CMAKE_CURRENT_SOURCE_DIR}/include/convert/convert.hpp
  PRIVATE
    ${CMAKE_CURRENT_SOURCE_DIR}/src/convert.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/src/conversions.f90
    ${CMAKE_CURRENT_BINARY_DIR}/include/convert/fortran_interface.h
)
# Include the default and generated include directories.
target_include_directories(cpp-fortran-mixed
  PUBLIC
    ${CMAKE_CURRENT_SOURCE_DIR}/include
  PRIVATE
    ${CMAKE_CURRENT_BINARY_DIR}/include
)

# Add the tests and link against the cpp-fortran-mixed library.
target_sources(exhale-projects-unit-tests
  PUBLIC
    ${CMAKE_CURRENT_SOURCE_DIR}/src/tests.cpp
)
target_link_libraries(exhale-projects-tests-interface
  INTERFACE
    cpp-fortran-mixed
)

=== testing/projects/cpp_func_overloads/CMakeLists.txt ===
--- 
+++ 
@@ -14,8 +14,10 @@
 target_sources(cpp-func-overloads
   PUBLIC
     ${CMAKE_CURRENT_SOURCE_DIR}/include/overload/overload.hpp
+    ${CMAKE_CURRENT_SOURCE_DIR}/include/overload/operators.hpp
   PRIVATE
     ${CMAKE_CURRENT_SOURCE_DIR}/src/overload.cpp
+    ${CMAKE_CURRENT_SOURCE_DIR}/src/operators.cpp
 )
 target_include_directories(cpp-func-overloads
   PUBLIC

=== testing/projects/cpp_pimpl/CMakeLists.txt ===
########################################################################################
# This file is dedicated to the public domain.  If your jurisdiction requires a        #
# specific license:                                                                    #
#                                                                                      #
# Copyright (c) Stephen McDowell, 2017-2022                                            #
# License:      CC0 1.0 Universal                                                      #
# License Text: https://creativecommons.org/publicdomain/zero/1.0/legalcode            #
########################################################################################
cmake_minimum_required(VERSION 3.13 FATAL_ERROR)
project(cpp-pimpl LANGUAGES CXX)

# Add the cpp-pimpl library
add_library(cpp-pimpl "")
target_sources(cpp-pimpl
  PUBLIC
    ${CMAKE_CURRENT_SOURCE_DIR}/include/pimpl/planet.hpp
    ${CMAKE_CURRENT_SOURCE_DIR}/include/pimpl/earth.hpp
    ${CMAKE_CURRENT_SOURCE_DIR}/include/pimpl/jupiter.hpp
  PRIVATE
    ${CMAKE_CURRENT_SOURCE_DIR}/src/earth.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/src/jupiter.cpp
)
target_include_directories(cpp-pimpl
  PUBLIC
    ${CMAKE_CURRENT_SOURCE_DIR}/include
)

# Add the tests and link against the cpp-pimpl library.
target_sources(exhale-projects-unit-tests
  PUBLIC
    ${CMAKE_CURRENT_SOURCE_DIR}/src/tests.cpp
)
target_link_libraries(exhale-projects-tests-interface
  INTERFACE
    cpp-pimpl
)

add_open_cpp_coverage_source_dirs(include src)

=== debian/changelog ===
exhale (0.3.6-2) unstable; urgency=medium

  * Use the shiny new pybuild-autopkgtest

 -- Timo Röhling <roehling@debian.org>  Thu, 08 Dec 2022 14:29:24 +0100

exhale (0.3.6-1) unstable; urgency=medium

  [ Debian Janitor ]
  * Set field Upstream-Name in debian/copyright.
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.

  [ Timo Röhling ]
  * Update d/watch
  * New upstream version 0.3.6

 -- Timo Röhling <roehling@debian.org>  Mon, 10 Oct 2022 21:08:27 +0200

=== debian/control ===
--- 
+++ 
@@ -21,6 +21,7 @@
 Rules-Requires-Root: no
 Vcs-Git: https://salsa.debian.org/python-team/packages/exhale.git
 Vcs-Browser: https://salsa.debian.org/python-team/packages/exhale
+Testsuite: autopkgtest-pkg-pybuild
 
 Package: python3-exhale
 Architecture: all

## exhale 0.3.7

=== docs/Makefile ===
# Minimal makefile for Sphinx documentation
#

# You can set these variables from the command line.
SPHINXOPTS    =
SPHINXBUILD   = sphinx-build
SPHINXPROJ    = Exhale
SOURCEDIR     = .
BUILDDIR      = _build

# Put it first so that "make" without argument is like "make help".
help:
	@$(SPHINXBUILD) -M help "$(SOURCEDIR)" "$(BUILDDIR)" $(SPHINXOPTS) $(O)

.PHONY: help Makefile

# Catch-all target: route all unknown targets to Sphinx using the new
# "make mode" option.  $(O) is meant as a shortcut for $(SPHINXOPTS).
%: Makefile
	@$(SPHINXBUILD) -M $@ "$(SOURCEDIR)" "$(BUILDDIR)" $(SPHINXOPTS) $(O)

=== docs/requirements.txt ===
sphinx
sphinx_rtd_theme
sphinx-issues
# exhale requirements
beautifulsoup4
lxml
breathe
six
# test imports
pytest
pytest-raises>=0.10

=== testing/projects/CMakeLists.txt ===
--- 
+++ 
@@ -2,7 +2,7 @@
 # This file is dedicated to the public domain.  If your jurisdiction requires a        #
 # specific license:                                                                    #
 #                                                                                      #
-# Copyright (c) Stephen McDowell, 2017-2022                                            #
+# Copyright (c) Stephen McDowell, 2017-2024                                            #
 # License:      CC0 1.0 Universal                                                      #
 # License Text: https://creativecommons.org/publicdomain/zero/1.0/legalcode            #
 ########################################################################################

=== testing/projects/c_maths/CMakeLists.txt ===
--- 
+++ 
@@ -2,7 +2,7 @@
 # This file is dedicated to the public domain.  If your jurisdiction requires a        #
 # specific license:                                                                    #
 #                                                                                      #
-# Copyright (c) Stephen McDowell, 2017-2022                                            #
+# Copyright (c) Stephen McDowell, 2017-2024                                            #
 # License:      CC0 1.0 Universal                                                      #
 # License Text: https://creativecommons.org/publicdomain/zero/1.0/legalcode            #
 ########################################################################################

=== testing/projects/cpp with spaces/CMakeLists.txt ===
--- 
+++ 
@@ -2,7 +2,7 @@
 # This file is dedicated to the public domain.  If your jurisdiction requires a        #
 # specific license:                                                                    #
 #                                                                                      #
-# Copyright (c) Stephen McDowell, 2017-2022                                            #
+# Copyright (c) Stephen McDowell, 2017-2024                                            #
 # License:      CC0 1.0 Universal                                                      #
 # License Text: https://creativecommons.org/publicdomain/zero/1.0/legalcode            #
 ########################################################################################

=== testing/projects/cpp_dir_underscores/CMakeLists.txt ===
--- 
+++ 
@@ -2,7 +2,7 @@
 # This file is dedicated to the public domain.  If your jurisdiction requires a        #
 # specific license:                                                                    #
 #                                                                                      #
-# Copyright (c) Stephen McDowell, 2017-2022                                            #
+# Copyright (c) Stephen McDowell, 2017-2024                                            #
 # License:      CC0 1.0 Universal                                                      #
 # License Text: https://creativecommons.org/publicdomain/zero/1.0/legalcode            #
 ########################################################################################

=== testing/projects/cpp_fortran_mixed/CMakeLists.txt ===
--- 
+++ 
@@ -2,7 +2,7 @@
 # This file is dedicated to the public domain.  If your jurisdiction requires a        #
 # specific license:                                                                    #
 #                                                                                      #
-# Copyright (c) Stephen McDowell, 2017-2022                                            #
+# Copyright (c) Stephen McDowell, 2017-2024                                            #
 # License:      CC0 1.0 Universal                                                      #
 # License Text: https://creativecommons.org/publicdomain/zero/1.0/legalcode            #
 ########################################################################################

=== testing/projects/cpp_func_overloads/CMakeLists.txt ===
--- 
+++ 
@@ -2,7 +2,7 @@
 # This file is dedicated to the public domain.  If your jurisdiction requires a        #
 # specific license:                                                                    #
 #                                                                                      #
-# Copyright (c) Stephen McDowell, 2017-2022                                            #
+# Copyright (c) Stephen McDowell, 2017-2024                                            #
 # License:      CC0 1.0 Universal                                                      #
 # License Text: https://creativecommons.org/publicdomain/zero/1.0/legalcode            #
 ########################################################################################

=== testing/projects/cpp_long_names/CMakeLists.txt ===
--- 
+++ 
@@ -2,7 +2,7 @@
 # This file is dedicated to the public domain.  If your jurisdiction requires a        #
 # specific license:                                                                    #
 #                                                                                      #
-# Copyright (c) Stephen McDowell, 2017-2022                                            #
+# Copyright (c) Stephen McDowell, 2017-2024                                            #
 # License:      CC0 1.0 Universal                                                      #
 # License Text: https://creativecommons.org/publicdomain/zero/1.0/legalcode            #
 ########################################################################################

=== testing/projects/cpp_nesting/CMakeLists.txt ===
--- 
+++ 
@@ -2,7 +2,7 @@
 # This file is dedicated to the public domain.  If your jurisdiction requires a        #
 # specific license:                                                                    #
 #                                                                                      #
-# Copyright (c) Stephen McDowell, 2017-2022                                            #
+# Copyright (c) Stephen McDowell, 2017-2024                                            #
 # License:      CC0 1.0 Universal                                                      #
 # License Text: https://creativecommons.org/publicdomain/zero/1.0/legalcode            #
 ########################################################################################

=== testing/projects/cpp_pimpl/CMakeLists.txt ===
--- 
+++ 
@@ -2,7 +2,7 @@
 # This file is dedicated to the public domain.  If your jurisdiction requires a        #
 # specific license:                                                                    #
 #                                                                                      #
-# Copyright (c) Stephen McDowell, 2017-2022                                            #
+# Copyright (c) Stephen McDowell, 2017-2024                                            #
 # License:      CC0 1.0 Universal                                                      #
 # License Text: https://creativecommons.org/publicdomain/zero/1.0/legalcode            #
 ########################################################################################

=== debian/changelog ===
exhale (0.3.7-1) unstable; urgency=medium

  * New upstream version 0.3.7

 -- Timo Röhling <roehling@debian.org>  Tue, 06 Feb 2024 21:06:03 +0100

exhale (0.3.6-5) unstable; urgency=medium

  * Skip mixed Fortran test completely

 -- Timo Röhling <roehling@debian.org>  Thu, 12 Oct 2023 11:04:28 +0200

exhale (0.3.6-4) unstable; urgency=medium

  * Clean test build files (Closes: #1044900)
  * Hotfix for Fortran signature change (Closes: #1052910)

 -- Timo Röhling <roehling@debian.org>  Wed, 11 Oct 2023 19:22:36 +0200

exhale (0.3.6-3) unstable; urgency=medium

  * Fix Sphinx 7 compatibility
  * Bump Standards-Version to 4.6.2

 -- Timo Röhling <roehling@debian.org>  Wed, 30 Aug 2023 22:10:12 +0200

=== debian/control ===
--- 
+++ 
@@ -17,7 +17,7 @@
   python3-six,
   python3-sphinx,
 Homepage: https://exhale.readthedocs.io/en/latest/
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Rules-Requires-Root: no
 Vcs-Git: https://salsa.debian.org/python-team/packages/exhale.git
 Vcs-Browser: https://salsa.debian.org/python-team/packages/exhale

=== debian/rules ===
--- 
+++ 
@@ -1,6 +1,6 @@
 #!/usr/bin/make -f
 
-export PYBUILD_TEST_ARGS = $(CURDIR)/testing -m "not setup_raises" -k "not CPPNestingPages"
+export PYBUILD_TEST_ARGS = $(CURDIR)/testing -m "not setup_raises" -k "not CPPNestingPages and not CPPFortranMixed" 
 
 %:
 	dh $@ --buildsystem=pybuild

=== debian/watch ===
version=4
opts=searchmode=plain,filenamemangle=s%(?:.*?/)?v?@ANY_VERSION@%@PACKAGE@-$1.tar.gz% \
 https://api.github.com/repos/svenevs/exhale/tags \
 tarball/(?:[^"]*?/)?v?@ANY_VERSION@
